﻿Public Class ValidateTextbox
    Inherits System.Windows.Forms.TextBox
    Enum RestrictionCategory

        NoRestriction
        NumeralsOnly
        LettersOnly
        AlphanumericOnly

    End Enum

    Private _allowedKeys As RestrictionCategory


    Property AllowedKeys() As RestrictionCategory

        Get
            Return _allowedKeys
        End Get

        Set(ByVal Value As RestrictionCategory)
            Select Case Value
                Case 1 To 3 ' One of the enum choices
                    _allowedKeys = Value
                Case Else ' No restriction
                    _allowedKeys = 0
            End Select

        End Set

    End Property


    Protected Overrides Sub OnKeyPress(ByVal e As KeyPressEventArgs)

        MyBase.OnKeyPress(e)

        '  Test whether key is allowed, based on the current choice
        '  from the enum

        Select Case _allowedKeys

            Case 1 'Numerals only

                If IsNumeric(e.KeyChar) Then
                    'Exit Sub
                Else
                    e.Handled = True
                End If

            Case 2  ' Letters Only

                If e.KeyChar Like "[A-z]" Then
                    'Exit Sub
                Else
                    e.Handled = True
                End If

            Case 3  ' Alphanumeric
                If e.KeyChar Like "[A-z]" _
                Or IsNumeric(e.KeyChar) Then
                    ' Exit Sub
                Else
                    e.Handled = True
                End If

        End Select

    End Sub

End Class
